=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module Shippo
  class OrderRequest
    # Currency of the total_price and total_tax amounts. Required if total_price is provided
    attr_accessor :currency

    attr_accessor :from_address

    # Array of line item objects representing the items in this order. All objects will be returned expanded by default.
    attr_accessor :line_items

    # Custom buyer- or seller-provided notes about the order.
    attr_accessor :notes

    # An alphanumeric identifier for the order used by the seller/buyer. This identifier doesn't need to be unique.
    attr_accessor :order_number

    # Current state of the order.
    attr_accessor :order_status

    # Date and time when the order was placed. This datetime can be different from the datetime of the order object creation on Shippo.
    attr_accessor :placed_at

    # Amount paid by the buyer for shipping. This amount can be different from the price the seller will actually pay for shipping.
    attr_accessor :shipping_cost

    # Currency of the shipping_cost amount. Required if shipping_cost is provided
    attr_accessor :shipping_cost_currency

    # Shipping method (carrier + service or other free text description) chosen by the buyer. This value can be different from the shipping method the seller will actually choose.
    attr_accessor :shipping_method

    attr_accessor :subtotal_price

    attr_accessor :to_address

    # Total amount paid by the buyer for this order.
    attr_accessor :total_price

    # Total tax amount paid by the buyer for this order.
    attr_accessor :total_tax

    attr_accessor :weight

    attr_accessor :weight_unit

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'currency' => :'currency',
        :'from_address' => :'from_address',
        :'line_items' => :'line_items',
        :'notes' => :'notes',
        :'order_number' => :'order_number',
        :'order_status' => :'order_status',
        :'placed_at' => :'placed_at',
        :'shipping_cost' => :'shipping_cost',
        :'shipping_cost_currency' => :'shipping_cost_currency',
        :'shipping_method' => :'shipping_method',
        :'subtotal_price' => :'subtotal_price',
        :'to_address' => :'to_address',
        :'total_price' => :'total_price',
        :'total_tax' => :'total_tax',
        :'weight' => :'weight',
        :'weight_unit' => :'weight_unit'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'currency' => :'Object',
        :'from_address' => :'Object',
        :'line_items' => :'Object',
        :'notes' => :'Object',
        :'order_number' => :'Object',
        :'order_status' => :'Object',
        :'placed_at' => :'Object',
        :'shipping_cost' => :'Object',
        :'shipping_cost_currency' => :'Object',
        :'shipping_method' => :'Object',
        :'subtotal_price' => :'Object',
        :'to_address' => :'Object',
        :'total_price' => :'Object',
        :'total_tax' => :'Object',
        :'weight' => :'Object',
        :'weight_unit' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Shippo::OrderRequest` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Shippo::OrderRequest`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'currency')
        self.currency = attributes[:'currency']
      end

      if attributes.key?(:'from_address')
        self.from_address = attributes[:'from_address']
      end

      if attributes.key?(:'line_items')
        if (value = attributes[:'line_items']).is_a?(Array)
          self.line_items = value
        end
      end

      if attributes.key?(:'notes')
        self.notes = attributes[:'notes']
      end

      if attributes.key?(:'order_number')
        self.order_number = attributes[:'order_number']
      end

      if attributes.key?(:'order_status')
        self.order_status = attributes[:'order_status']
      end

      if attributes.key?(:'placed_at')
        self.placed_at = attributes[:'placed_at']
      end

      if attributes.key?(:'shipping_cost')
        self.shipping_cost = attributes[:'shipping_cost']
      end

      if attributes.key?(:'shipping_cost_currency')
        self.shipping_cost_currency = attributes[:'shipping_cost_currency']
      end

      if attributes.key?(:'shipping_method')
        self.shipping_method = attributes[:'shipping_method']
      end

      if attributes.key?(:'subtotal_price')
        self.subtotal_price = attributes[:'subtotal_price']
      end

      if attributes.key?(:'to_address')
        self.to_address = attributes[:'to_address']
      end

      if attributes.key?(:'total_price')
        self.total_price = attributes[:'total_price']
      end

      if attributes.key?(:'total_tax')
        self.total_tax = attributes[:'total_tax']
      end

      if attributes.key?(:'weight')
        self.weight = attributes[:'weight']
      end

      if attributes.key?(:'weight_unit')
        self.weight_unit = attributes[:'weight_unit']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @placed_at.nil?
        invalid_properties.push('invalid value for "placed_at", placed_at cannot be nil.')
      end

      if @to_address.nil?
        invalid_properties.push('invalid value for "to_address", to_address cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      order_status_validator = EnumAttributeValidator.new('Object', ['UNKNOWN', 'AWAITPAY', 'PAID', 'REFUNDED', 'REFUNDED', 'PARTIALLY_FULFILLED', 'SHIPPED'])
      return false unless order_status_validator.valid?(@order_status)
      return false if @placed_at.nil?
      return false if @to_address.nil?
      weight_unit_validator = EnumAttributeValidator.new('Object', ['g', 'kg', 'lb', 'oz'])
      return false unless weight_unit_validator.valid?(@weight_unit)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] order_status Object to be assigned
    def order_status=(order_status)
      validator = EnumAttributeValidator.new('Object', ['UNKNOWN', 'AWAITPAY', 'PAID', 'REFUNDED', 'REFUNDED', 'PARTIALLY_FULFILLED', 'SHIPPED'])
      unless validator.valid?(order_status)
        fail ArgumentError, "invalid value for \"order_status\", must be one of #{validator.allowable_values}."
      end
      @order_status = order_status
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] weight_unit Object to be assigned
    def weight_unit=(weight_unit)
      validator = EnumAttributeValidator.new('Object', ['g', 'kg', 'lb', 'oz'])
      unless validator.valid?(weight_unit)
        fail ArgumentError, "invalid value for \"weight_unit\", must be one of #{validator.allowable_values}."
      end
      @weight_unit = weight_unit
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          currency == o.currency &&
          from_address == o.from_address &&
          line_items == o.line_items &&
          notes == o.notes &&
          order_number == o.order_number &&
          order_status == o.order_status &&
          placed_at == o.placed_at &&
          shipping_cost == o.shipping_cost &&
          shipping_cost_currency == o.shipping_cost_currency &&
          shipping_method == o.shipping_method &&
          subtotal_price == o.subtotal_price &&
          to_address == o.to_address &&
          total_price == o.total_price &&
          total_tax == o.total_tax &&
          weight == o.weight &&
          weight_unit == o.weight_unit
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [currency, from_address, line_items, notes, order_number, order_status, placed_at, shipping_cost, shipping_cost_currency, shipping_method, subtotal_price, to_address, total_price, total_tax, weight, weight_unit].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Shippo.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
